package czerwony.kapturek.jbspell;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.*;
import java.lang.reflect.*;
import com.borland.jbcl.layout.*;
import com.borland.primetime.ide.*;
import com.borland.primetime.properties.*;
import com.borland.primetime.help.HelpTopic;


public class ConfigPanel extends PropertyPage
{
    private JLabel labelSpellCheckerPlugin = new JLabel();
    private JComboBox comboSpellCheckerPlugin = new JComboBox();
    private JButton buttonSpellCheckerPlugin = new JButton();

    private JCheckBox checkStrings = new JCheckBox();
    private JCheckBox checkJavaDoc = new JCheckBox();
    private JCheckBox checkComments = new JCheckBox();
    private JCheckBox checkEverything = new JCheckBox();
    private JCheckBox checkEverythingInSelections = new JCheckBox();
    private JCheckBox checkHighlightAllCheckedWords = new JCheckBox("Highlight all checked words");

    private JLabel labelMinLength1 = new JLabel();
    private JLabel labelMinLength2 = new JLabel();
    private JTextField textMinLength = new JTextField();

    private JCheckBox checkUseNativeMenus = new JCheckBox();

    private JCheckBox checkIgnoreJavaDocTags = new JCheckBox("Ignore JavaDoc @tags");

    private JPanel panel1 = new JPanel();
    private JPanel panel2 = new JPanel();
    private JPanel panel3 = new JPanel();
    private JPanel panel4 = new JPanel();
    private JPanel panel5 = new JPanel();


    public ConfigPanel()
    {
        initUi();
        initListeners();
    }


    private void initUi()
    {
        setLayout(new VerticalFlowLayout(VerticalFlowLayout.LEFT, 5, 10, true, true));

        labelSpellCheckerPlugin.setText("Spell checker plugin:");
        buttonSpellCheckerPlugin.setText("Configure...");
        panel1.setLayout(new BorderLayout(5, 5));
        panel1.setBorder(new EmptyBorder(0, 5, 0, 5));
        panel1.add(labelSpellCheckerPlugin, BorderLayout.WEST);
        panel1.add(comboSpellCheckerPlugin, BorderLayout.CENTER);
        panel1.add(buttonSpellCheckerPlugin, BorderLayout.EAST);

        //panel2.setBorder(new TitledBorder("\"Check text\" action scope"));
        panel2.setLayout(new VerticalFlowLayout(VerticalFlowLayout.LEFT, 0, 0, true, false));
        panel2.setBorder(new EmptyBorder(0, 5, 0, 5));
        checkStrings.setText("Check strings");
        checkJavaDoc.setText("JavaDoc");
        checkComments.setText("Check comments");
        checkEverything.setText("Check everything");
        checkEverythingInSelections.setText("Always check everything in selections");
        JPanel panel = new JPanel(new GridLayout(1, 3));//FlowLayout.LEFT));
        panel.add(checkStrings);
//        panel.add(checkJavaDoc);
        panel.add(checkComments);
        panel.add(checkEverything);
        panel2.add(panel);
//        panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        panel2.add(checkEverythingInSelections);
//        panel2.add(panel);
        panel2.add(checkHighlightAllCheckedWords);

        labelMinLength1.setText("Do not check words with ");
        labelMinLength2.setText(" or less characters (0==check all words)");
        panel3.setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));
        panel3.setBorder(new EmptyBorder(0, 5, 10, 5));
        textMinLength.setMinimumSize(new Dimension(30, 21));
        textMinLength.setPreferredSize(new Dimension(30, 21));
        panel3.add(labelMinLength1);
        panel3.add(textMinLength);
        panel3.add(labelMinLength2);

        panel4.setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));
        panel4.setBorder(new EmptyBorder(0, 5, 10, 5));
        checkUseNativeMenus.setText("Use native (AWT) popup menus");
        panel4.add(checkUseNativeMenus);

        panel5.setLayout(new FlowLayout(FlowLayout.LEFT, 0, 0));
        panel5.setBorder(new EmptyBorder(0, 5, 10, 5));
        panel5.add(checkIgnoreJavaDocTags);

        add(makeHeader("General"));
        add(panel1, null);
        add(panel4, null);
        add(makeHeader("\"Check File\" action specific"));
        add(panel2, null);
        add(panel3, null);
        add(makeHeader("Java specific"));
        add(panel5, null);
    }


    private JLabel makeHeader(String title)
    {
        JLabel header = new JLabel(title);
        header.setOpaque(true);
        header.setBackground(header.getBackground().brighter());
        header.setForeground(header.getForeground().darker());
        header.setHorizontalAlignment(JLabel.CENTER);
        return header;
    }


    private void initListeners()
    {
        ActionListener al = new CheckboxAdjuster();
        checkStrings.addActionListener(al);
        checkComments.addActionListener(al);
        checkJavaDoc.addActionListener(al);
        checkEverything.addActionListener(al);
        buttonSpellCheckerPlugin.addActionListener(new ActionListener()
            {
                public void actionPerformed(ActionEvent ev)
                {
                    try
                    {
//                        Class pluginClass = Class.forName(Settings.pluginName.getValue());
//                        Class[] paramTypes = new Class[0];
//                        Method m = pluginClass.getMethod("getInstance", paramTypes);
//                        Object[] param = new Object[0];
//                        AbstractChecker checker = (AbstractChecker)m.invoke(null, param);
                        String implName = comboSpellCheckerPlugin.getSelectedItem().toString();
                        Object implConfigTopic = SpellCheckerTool.getSpellCheckerConfigTopic(implName);
                        boolean b = PropertyManager.showPropertyDialog(ConfigPanel.this, "", implConfigTopic, "");
                    }
                    catch (Exception ex)
                    {
                        ex.printStackTrace();
                    }
                }
            });
    }


    public void readProperties()
    {
        String[] implementations = SpellCheckerTool.getSpellCheckerImplementations();
        if (implementations != null)
        {
            for (int i = 0; i < implementations.length; i++)
            {
                comboSpellCheckerPlugin.addItem(implementations[i]);
            }
            comboSpellCheckerPlugin.setSelectedItem(Settings.pluginName.getValue());
        }
        checkStrings.setSelected(Settings.checkStrings.getBoolean());
        checkJavaDoc.setSelected(Settings.checkJavaDoc.getBoolean());
        checkComments.setSelected(Settings.checkComments.getBoolean());
        checkEverything.setSelected(Settings.checkEverything.getBoolean());
        checkEverythingInSelections.setSelected(Settings.checkEverythingInSelections.getBoolean());
        checkHighlightAllCheckedWords.setSelected(Settings.highlightAllCheckedWord.getBoolean());
        adjustCheckBoxes();
        textMinLength.setText(Integer.toString(Settings.minWordLength.getInteger()));
        checkUseNativeMenus.setSelected(Settings.useNativeMenus.getBoolean());
        checkIgnoreJavaDocTags.setSelected(Settings.ignoreJavaDocTags.getBoolean());
    }


    public void writeProperties()
    {
        Object plugin = comboSpellCheckerPlugin.getSelectedItem();
        if ((plugin != null) && (plugin.toString().length() > 0))
        {
            Settings.pluginName.setValue(plugin.toString());
        }
        Settings.checkStrings.setBoolean(checkStrings.isSelected());
        Settings.checkJavaDoc.setBoolean(checkJavaDoc.isSelected());
        Settings.checkComments.setBoolean(checkComments.isSelected());
        Settings.checkEverything.setBoolean(checkEverything.isSelected());
        Settings.checkEverythingInSelections.setBoolean(checkEverythingInSelections.isSelected());
        Settings.highlightAllCheckedWord.setBoolean(checkHighlightAllCheckedWords.isSelected());
        int minWordLength = Integer.parseInt(textMinLength.getText());
        Settings.minWordLength.setInteger(minWordLength);
        Settings.useNativeMenus.setBoolean(checkUseNativeMenus.isSelected());
        Settings.ignoreJavaDocTags.setBoolean(checkIgnoreJavaDocTags.isSelected());
    }


    public HelpTopic getHelpTopic()
    {
        return null;
    }


    private void adjustCheckBoxes()
    {
        boolean everything = checkEverything.isSelected();
        if (everything)
        {
            checkStrings.setSelected(true);
            checkJavaDoc.setSelected(true);
            checkComments.setSelected(true);
        }
        boolean comments = checkComments.isSelected();
        if (comments)
        {
            checkJavaDoc.setSelected(true);
        }
        checkStrings.setEnabled(!everything);
        checkJavaDoc.setEnabled(!everything && !comments);
        checkComments.setEnabled(!everything);
    }


    private class CheckboxAdjuster implements ActionListener
    {
        public void actionPerformed(ActionEvent ev)
        {
            adjustCheckBoxes();
        }
    }
}