package czerwony.kapturek.jbspell;

import com.borland.primetime.properties.*;
import com.borland.primetime.editor.*;

public class Settings implements PropertyGroup
{
    public final static String TXT_PAGE_NAME = "Spell Checker";
    public final static String CATEGORY = "czerwony.kapturek.jbspell";
    public final static GlobalBooleanProperty   checkStrings = new GlobalBooleanProperty(CATEGORY, "checkStrings", true);
    public final static GlobalBooleanProperty   checkJavaDoc = new GlobalBooleanProperty(CATEGORY, "checkJavaDoc", true);
    public final static GlobalBooleanProperty   checkComments = new GlobalBooleanProperty(CATEGORY, "checkComments", true);
    public final static GlobalBooleanProperty   checkEverything = new GlobalBooleanProperty(CATEGORY, "checkEverything", false);
    public final static GlobalBooleanProperty   checkEverythingInSelections = new GlobalBooleanProperty(CATEGORY, "checkEverythingInSelections", true);
    public final static GlobalBooleanProperty   highlightAllCheckedWord = new GlobalBooleanProperty(CATEGORY, "highlightAllCheckedWord", false);

    public final static GlobalIntegerProperty   minWordLength = new GlobalIntegerProperty(CATEGORY, "minWordLength", 0);
    public final static GlobalProperty          pluginName = new GlobalProperty(CATEGORY, "pluginName", "");

    public final static GlobalBooleanProperty   useNativeMenus = new GlobalBooleanProperty(CATEGORY, "useNativeMenus", true);

    public final static GlobalBooleanProperty   ignoreJavaDocTags = new GlobalBooleanProperty(CATEGORY, "ignoreJavaDocTags", true);

    public final static GlobalBooleanProperty   noSpellCheckCompletedMessage = new GlobalBooleanProperty(CATEGORY, "noSpellCheckCompletedMessage", false);

    public Settings()
    {
    }


    public void initializeProperties()
    {
    }


    public PropertyPageFactory getPageFactory(Object topic)
    {
        PropertyPageFactory factory;
        if (topic == EditorManager.EDITOR_TOPIC)
        {
            factory = new SpellCheckerFactory();
        }
        else
        {
            factory = null;
        }
        return factory;
    }


    public class SpellCheckerFactory extends PropertyPageFactory
    {
        public SpellCheckerFactory()
        {
            super(TXT_PAGE_NAME);
        }

        public PropertyPage createPropertyPage()
        {
            return new ConfigPanel();
        }
    }
}